<?php
/*	Navigation mit ALKIS-Daten im Mapbender 2.7 - Teil "Einstellungen"
	Diese Version des Programms verwendet die Datenbank-Struktur aus dem norGIS-ALKIS-Importer.

Version vom
	2016-08-17 GKZ in ALKIS-DB-Name 4stellig
	2016-11-28 Gemeinsam genutzte Datenbanken ermglichen (mehrere Gemeinden in Kreis-Datenbank)
	2021-11-22 Parameter $katamtmix (Kataster-Amt-Mix)
*/

//	im Normalfall  ...
	$dbgkz = $gkz;				// eine Datenbank je Mandant
	$dbhost = '10.0.___';	// Datenbank-Server aus Produktion

	$katamtmix = false;	// Default. Sind Daten aus verschiedenen Katasteramts-Bezirken in der DB?

	switch ($gkz) {	// lokale und temporre Besonderheiten je Mandant

		case "150": // Testfall
			$dbhost = 'localhost'; // Datenbank auf dem DIESEM TEST-Server verwenden
			break;

		case "rlp": 
			$dbhost = 'localhost'; // Datenbank auf dem DIESEM TEST-Server verwenden
			break;

		case "320":
			$dbgkz = '300';		// gemeinsame Datenbank fr das Kreisgebiet
			$filtkreis='70';
			$filtgem = '16';	// Gebiets-Filter kommen derzeit noch aus der Mapbender-Konfiguration
			break;

		case "418":
			$katamtmix = true;	// Katasteramt Mix
			break;

	}

//	DB-Connection
	$dbport="5432";
	$dbpre="alkis0"; // Datenbanken aus dem norGIS-ALKIS-Importer
	$dbuser="___";
	$dbpass="___";

#	Pfad zu den ALKIS-Auskunft-Programmen
	$auskpath="../../../alkisn/";		// AUSKUNFT auf norBIT-DB

#	Massstab zum Positionieren auf Flurstueck, Strasse, Hausnummer
#	in MapProxy gecachte Masstaebe verwenden
	$scalefs=750;
	$scalestr=2500;
	$scalehs=500;

#	default-Koordinatensystem der GUI
	$gui_epsg=25832;

#	Landes-Kennung
	$land="05"; // NRW

#	Filter:
#	Liste der relevanten Amtsgerichts-Nummern aus ax_dienststelle.stelle
#	Form: SQL WHERE IN ()
#	Bei leerer Eingabe in Tab 'Grundb.'
	$ag_liste = "'2102','2105','2106','2107','2108','2110','2303','2307'";

#	Nur Personen anzeigen, die Eigentum in der Gemeinde (-liste) haben
#	"true" setzt voraus, dass die Hilfstabelle "gemeinde_person" gefuellt ist
	$persfilter=true;

#	hausnummernohnegebaeude - sollen Hausnummern ohne Gebude ausgegeben werden?
#	1 ja / 0 nein
	$hausnummernohnegebaeude = 1;

#	Entwicklungsumgebung
	$debug=1; // 0=Produktion, 1=mit Fehlermeldungen, 2=mit Informationen, 3=mit SQL

//	Datenbank-Connection-String aus den oben konfigurierten Parametern bilden
	$dbconn = "host=".$dbhost." port=".$dbport." dbname=".$dbpre.$dbgkz." user=".$dbuser." password=".$dbpass." options='--application_name=alkisnav'";

?>